	.module TinyLCD_Uart.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Uart.c
	.dbfunc e putchar _putchar fV
;        tmphead -> R20
;         indata -> R16
	.even
_putchar::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 68
; /**************************************************************
; 
;    Program Title:  TinyLCD Controller
;    
;    Program Name:  TinyLCD_Uart.c	Version: 0.85
;    
;    Author:  SS	  			    Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement basic Usart put/get functions.
;    
;    Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: TinyLCD_Uart.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "TinyLCD_Uart.h"
; #include "TinyLCD_Defines.h"
; #include "TinyLCD_Extern.h"
; 
; void putchar(unsigned char indata)
; {
	.dbline 72
; 	unsigned char tmphead;
; 	
; 	// Calculate buffer index
; 	tmphead = (UART_TxHead + 1) & UART_TX_BUFFER_MASK; 
	lds R20,_UART_TxHead
	subi R20,255    ; addi 1
	andi R20,63
L2:
	.dbline 75
; 		
; 	// Wait for free space in buffer
; 	while(tmphead == UART_TxTail) ;
L3:
	.dbline 75
	lds R2,_UART_TxTail
	cp R20,R2
	breq L2
X0:
	.dbline 77
; 	
; 	UART_TxBuf[tmphead] = indata; // store data in buffer
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 78
; 	UART_TxHead = tmphead;      // store new index
	sts _UART_TxHead,R20
	.dbline 81
; 
; 	// Expand LF to CRLF is textmode globel set
; 	if((indata==LF)&&(_textmode==1)) {
	cpi R16,10
	brne L5
X1:
	lds R24,__textmode
	lds R25,__textmode+1
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L5
X2:
	.dbline 81
	.dbline 83
; 		// Calculate buffer index
; 		tmphead = (UART_TxHead + 1) & UART_TX_BUFFER_MASK; 
	subi R20,255    ; addi 1
	andi R20,63
L7:
	.dbline 86
; 		
; 		// Wait for free space in buffer
; 		while(tmphead == UART_TxTail) ;
L8:
	.dbline 86
	lds R2,_UART_TxTail
	cp R20,R2
	breq L7
X3:
	.dbline 88
; 	
; 		UART_TxBuf[tmphead] = CR; // store data in buffer
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,13
	std z+0,R24
	.dbline 89
; 		UART_TxHead = tmphead;      // store new index
	sts _UART_TxHead,R20
	.dbline 90
; 		}
L5:
	.dbline 92
; 
; 	UCSR0B |= (1<<UDRIE0);        // Fire TX UDRIE interrupt
	lds R24,193
	ori R24,32
	sts 193,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r tmphead 20 c
	.dbsym r indata 16 c
	.dbend
	.dbfunc e getcharnw _getcharnw fc
;          rxtmp -> <dead>
;        tmptail -> R16
	.even
_getcharnw::
	.dbline -1
	.dbline 97
; }
; 
; // Read and write functions
; unsigned char getcharnw(void)
; {
	.dbline 100
; 	unsigned char tmptail,rxtmp;
; 
; 	if(UART_RxHead==UART_RxTail) return 0; // nothing to get
	lds R2,_UART_RxTail
	lds R3,_UART_RxHead
	cp R3,R2
	brne L11
X4:
	.dbline 100
	clr R16
	xjmp L10
L11:
	.dbline 102
; 		
; 	tmptail = (UART_RxTail+1)&UART_RX_BUFFER_MASK;  // calculate buffer index
	lds R16,_UART_RxTail
	subi R16,255    ; addi 1
	andi R16,63
	.dbline 103
; 	UART_RxTail = tmptail;     // store new index
	sts _UART_RxTail,R16
	.dbline 105
; 	
; 	rxcnt--;
	lds R24,_rxcnt
	subi R24,1
	sts _rxcnt,R24
	.dbline 106
; 	if(rxcnt<0) rxcnt = 0;
	cpi R24,0
	brsh L13
X5:
	.dbline 106
	clr R2
	sts _rxcnt,R2
L13:
	.dbline 108
; 
; 	return UART_RxBuf[tmptail];   // return data
	ldi R24,<_UART_RxBuf
	ldi R25,>_UART_RxBuf
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	.dbline -2
L10:
	.dbline 0 ; func end
	ret
	.dbsym l rxtmp 1 c
	.dbsym r tmptail 16 c
	.dbend
	.dbfunc e getchar _getchar fc
;         inchar -> R10
	.even
_getchar::
	st -y,R10
	.dbline -1
	.dbline 113
; }
; 
; // Getchar waits until a valid character is received
; unsigned char getchar(void)
; {
L16:
	.dbline 116
;     unsigned char inchar;
; 	
;  	while(!(inchar=getcharnw())) ;
L17:
	.dbline 116
	xcall _getcharnw
	mov R10,R16
	tst R10
	breq L16
X6:
	.dbline 117
; 	if(echoinchars==YES) putchar(inchar);
	lds R24,_echoinchars
	cpi R24,1
	brne L19
X7:
	.dbline 117
	xcall _putchar
L19:
	.dbline 118
; 	return inchar;
	mov R16,R10
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e InittUART _InittUART fV
;       baudrate -> R16
	.even
_InittUART::
	.dbline -1
	.dbline 123
; }
; 
; /* Initialize UART */
; void InittUART(unsigned char baudrate)
; {
	.dbline 125
;  	/* set the baud rate */
; 	UBRR0H = 0x00;
	clr R2
	sts 197,R2
	.dbline 126
; 	UBRR0L = baudrate; 
	sts 196,R16
	.dbline 127
; 	UCSR0B = BIT(RXEN0) | BIT(TXEN0); /* enable UART receiver and transmitter */
	ldi R24,24
	sts 193,R24
	.dbline 131
;     //  8 data bits, 2 stop bits
; //	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
;     //  8 data bits, 1 stop bit
; 	UCSR0C = (1<<UMSEL01)|(3<<UCSZ01);
	ldi R24,140
	sts 194,R24
	.dbline -2
L21:
	.dbline 0 ; func end
	ret
	.dbsym r baudrate 16 c
	.dbend
	.dbfunc e ReceiveByte _ReceiveByte fc
	.even
_ReceiveByte::
	.dbline -1
	.dbline 136
; }
; 
; // Polled receive function - non-wait
; unsigned char ReceiveByte(void)
; {
	.dbline 137
; 	if((UCSR0A & (1<<RXB80))) return UDR0;
	lds R2,192
	sbrs R2,1
	rjmp L23
X8:
	.dbline 137
	lds R16,198
	xjmp L22
L23:
	.dbline 138
; 	else return 0x00;
	clr R16
	.dbline -2
L22:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TransmitByte _TransmitByte fV
;           data -> R16
	.even
_TransmitByte::
	.dbline -1
	.dbline 143
; }
; 
; // Polled transmit function
; void TransmitByte(unsigned char data)
; {
L26:
	.dbline 145
; 	while ( !(UCSR0A & (1<<UDRE0)) )
; 		; /* wait for empty transmit buffer */
L27:
	.dbline 144
	lds R2,192
	sbrs R2,5
	rjmp L26
X9:
	.dbline 146
; 	UDR0 = data; /* start transmission */
	sts 198,R16
	.dbline -2
L25:
	.dbline 0 ; func end
	ret
	.dbsym r data 16 c
	.dbend
	.dbfunc e puttchar _puttchar fV
;           data -> R10
	.even
_puttchar::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 151
; }
; 
; //  Buffered write to UART - wait until transmitted
; void puttchar(unsigned char data)
; {
	.dbline 152
;  	 TransmitByte(data);
	mov R16,R10
	xcall _TransmitByte
	.dbline -2
L29:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r data 10 c
	.dbend
	.dbfunc e gettchar _gettchar fc
;         inchar -> R10
	.even
_gettchar::
	st -y,R10
	.dbline -1
	.dbline 158
; }
; 
; //  Buffered character read from UART - don't return if 
; //  character is Null
; unsigned char gettchar(void)
; {
L31:
	.dbline 161
;      unsigned char inchar;
; 	 
;  	 while(!(inchar=ReceiveByte())) ;
L32:
	.dbline 161
	xcall _ReceiveByte
	mov R10,R16
	tst R10
	breq L31
X10:
	.dbline 162
;  	 return inchar;
	.dbline -2
L30:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e puts _puts fV
;              i -> R20,R21
;        outstrg -> R10,R11
	.even
_puts::
	xcall push_xgset300C
	movw R10,R16
	.dbline -1
	.dbline 166
; }
; 
; void puts(char *outstrg)
; {
	.dbline 169
;  	 int i;
; 	 
; 	 for(i=0; i<strlen(outstrg); i++)  putchar(outstrg[i]);
	clr R20
	clr R21
	xjmp L38
L35:
	.dbline 169
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _putchar
L36:
	.dbline 169
	subi R20,255  ; offset = 1
	sbci R21,255
L38:
	.dbline 169
	movw R16,R10
	xcall _strlen
	cp R20,R16
	cpc R21,R17
	brlo L35
X11:
	.dbline -2
L34:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 I
	.dbsym r outstrg 10 pc
	.dbend
	.dbfunc e putCRLF _putCRLF fV
	.even
_putCRLF::
	.dbline -1
	.dbline 173
; }
; 
; void putCRLF()
; {
	.dbline 174
;  	 puts("\n\r");
	ldi R16,<L40
	ldi R17,>L40
	xcall _puts
	.dbline -2
L39:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e putfs _putfs fV
;              i -> R20,R21
;         inchar -> R10
;        signon1 -> R12,R13
	.even
_putfs::
	xcall push_xgset303C
	movw R12,R16
	.dbline -1
	.dbline 179
; }
; 
; //  Load string constant from Flash (conserves RAM)
; void putfs(const char *signon1)
; { 	
	.dbline 183
; 	char inchar;
;     int i;
; 	
; 	i = 0;
	clr R20
	clr R21
	xjmp L43
L42:
	.dbline 184
; 	while((inchar=*(signon1+i++))!=0x00)  putchar(inchar);
	mov R16,R10
	xcall _putchar
L43:
	.dbline 184
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R2
	add R30,R12
	adc R31,R13
	lpm R2,Z
	mov R10,R2
	tst R10
	brne L42
X12:
	.dbline -2
L41:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r inchar 10 c
	.dbsym r signon1 12 pkc
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Uart.c
L40:
	.blkb 3
	.area idata
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Uart.c
; }
; 
