/**************************************************************

   Program Title: SmartLCD Controller 
   
   Program Name: SmartLCD_Accelerometer.h 		  Version: 0.01
   
   Author:  WR	  				  Date:  August 10, 2005
   
   Compiled with ImageCraft ICCAVR Standard V7.1
   
   Copyright 2004-2008, SOC Machines, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2008 by SOC Machines, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */


/*
* Defines the ranges that can be selected for the Accelerometer
*/
#define ACCELEROMETER_1g5 0
#define ACCELEROMETER_2g 1
#define ACCELEROMETER_4g 2
#define ACCELEROMETER_6g 3

/*
* Defines the sensitivity that can be selected for the Accelerometer
* mV/g
*/
#define ACCELEROMETER_1g5_SENSITIVITY 800
#define ACCELEROMETER_2g_SENSITIVITY 600
#define ACCELEROMETER_4g_SENSITIVITY 300
#define ACCELEROMETER_6g_SENSITIVITY 200

#define X_AXIS 0
#define Y_AXIS 1
#define Z_AXIS 2

/*
 *What port is the accelerometer connected to?
 */
#define ACCELEROMETER_CONTROL PORTB
/*
 *What port pins is the accelerometer connected to?
 */
#define GS1 3
#define GS2 4
#define SLEEP 5

void setAccelerometerRange(unsigned char range);
void enableAccelerometer(unsigned char sleep);
int readAccelerometer(unsigned char axis);


//extern void printint(int intvalue,int lineNumber);


