/**************************************************************

   Program Title:  TinyLCD Controller
   
   Program Name:  TinyLCD_Extern.h		  Version: 0.85
   
   Author:  SS	  				  		  Date:  Feb 10, 2006
   
   Compiled with ImageCraft ICCAVR Standard V7.02
   
   Copyright 2004-2006, SOC Machines, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2005 by SOC Machines, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */
/*
 * $Log: TinuLCD_Extern.h,v $
 * Revision 0.85  2005/07/17 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */

//  Variable declarations
extern unsigned int rtccountdown1,rtccountdown2,rtccountdown3,rtccountdown4;
extern unsigned int mseccountdown1,mseccountdown2,mseccountdown3,mseccountdown4;
extern unsigned int mseccountdown5;
extern unsigned int seconds,minutes,hours,days;

extern unsigned int totalbytecnt,xoncnt,xoffcnt;
extern unsigned char frameerror,dataoverrun,voltagevolume,rtcclockcnt;

extern int _textmode;

/* Static Variables */
extern unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
extern unsigned char UART_RxHead;
extern unsigned char UART_RxTail;
extern unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
extern unsigned char UART_TxHead;
extern unsigned char UART_TxTail;
extern char  xoffsent, xonsent, enablexonoff, echoinchars, sendxoff;
extern char  rxcnt,checkflag,rxcntmax;
extern unsigned char  instrg[8],vlow,vhigh,hexbyte[3];
extern char key1state,key2state,key3state,key4state;
extern char key1toggle,key2toggle,key3toggle,key4toggle;


extern unsigned char FlashAddress[3];
extern const char signon1[];
extern const char signon2[];
extern const char signon3[];
extern const char signon4[];
extern const char signon7[];
extern const char signon8[];
extern const char signon9[];
extern const char signon10[];

extern const char displaymessage1[];
extern const char displaymessage2[];
extern const char displaymessage3[];
extern const char displaymessage33[];

extern const char progmessage[];

extern const char displaymessage4[];
extern const char displaymessage5[];
extern const char displaymessage6[];

extern const char loadmessage1[];
extern const char loadmessage2[];
extern const char loadmessage3[];

// Function declarations
extern unsigned char EEPROMwrite(int,unsigned char);
extern unsigned char EEPROMread(int);

extern void InitUART(unsigned char baudrate);
extern void InitADC(void);
extern void InitRealTimeClock(void);
extern void Init_Timer0(void);
extern void InitWatchdog(void);
extern void Init_SPI_Master(void);
extern void Init_AVR(void);
extern void Delay(void);
extern void shortdelay(int cnt);
extern void LongDelay(int cnt);
extern void Delaymsec(int delayvalue);
extern void WriteEEPROM(int location, unsigned char *strg);
extern void EEPROMSetup(void);
extern char getint(void);
extern unsigned char ReadAVRFlash(int address);
extern void signon(void);
extern void ProgramVersion(void);
extern void PrintHex(unsigned char);
extern int  AnalogCh(int ch,char mode);
extern void DumpAnalogChs(void);
extern void TestAVR(void);
extern void Release_SPI(void);
extern unsigned char CheckKeyState(unsigned char key);
extern void SPI_MasterTransmit(unsigned char cData);
extern unsigned char SPI_MasterReceive(void);
extern void Init_TWI_Master(void);
extern void Init_TWI_Slave(unsigned char slaveaddress,char generalcall);
extern void TWI_Error(void);
extern void TWI_Off(void);
extern unsigned char  TWI_Transmit(unsigned char slaveaddress, unsigned char txdata,
                            unsigned char statusmode);
extern unsigned char TWI_Master_Receive(unsigned char slaveaddress);
extern void TestTWI(void);
extern void TWI_Write_Slave(void);
//extern void putchar(unsigned char data);
extern unsigned char getcharnw(void);
//extern unsigned char getchar(void);
extern void InittUART(unsigned char baudrate);
extern unsigned char ReceiveByte(void);
extern void TransmitByte(unsigned char data);
extern void puttchar(unsigned char data);
extern unsigned char gettchar(void);
int Read_ADC(unsigned char channel, unsigned char ref);
//extern void printint(int intvalue,char charcnt,char leadchartype);
//extern void puts(char *outstrg);
extern void putCRLF(void);
extern void putfs(const char *signon1);
extern void bytetohex(unsigned char byte);
extern void addresstohex(unsigned int address);
extern unsigned char converttohex(char *instrg);

extern void LCD_LED_Power(unsigned char state);
extern void LED_Power(unsigned char state);
extern void printint(int intvalue,unsigned char *text);




