/**************************************************************

   Program Title:  SmartLCD Controller
   
   Program Name:  SmartLCD_Defines.h		  Version: 0.85
   
   Author:  SS	  				  		  Date:  August 10, 2008
   
   Compiled with ImageCraft ICCAVR Standard V6.29
   
   Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2008 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */
/*
 * $Log: SmartLCD_Defines.c,v $
 * Revision 0.85  2005/07/17 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */

//  EEPROM Definitions
#define   MAJORVER   	 0
#define   MINORVER       87

// Other definitions
#define  LEEPROM   		 'e'
#define  LAVRFLASH 		 'a'
#define  LFLASH    		 'f'

#define  INTERNALREF     'i'
#define  EXTERNALREF	 'e'

#define	 ACTIVE			 'a'
#define	 INACTIVE		 'i'

#define  BAUDRATE2400	 204
#define  BAUDRATE4800	 102
#define  BAUDRATE9600    51
#define  BAUDRATE19200	 25
#define  BAUDRATE38400   11

// Serial Flash
#define	 FLASHBYTESPERPAGE 264
#define  SF_READ_CONT	 0xE8
#define  SF_READ_BUFFER1 0x54
#define  SF_READ_BUFFER2 0x56
#define  SF_WRITE_BUFFER1 0x84
#define  SF_WRITE_BUFFER2 0x87
#define  SF_BUF1_TO_FLASH_ERASE 0x83
#define  SF_BUF2_TO_FLASH_ERASE 0x86
#define  SF_BUF1_TO_FLASH_NOERASE 0x88
#define  SF_BUF2_TO_FLASH_NOERASE 0x89
#define  SF_FLASH_TO_BUF1 0x53
#define  SF_FLASH_TO_BUF2 0x55
#define  SF_PAGE_ERASE	  0x81
#define  SF_BLOCK_ERASE	  0x50
#define  SF_READ_STATUS	  0xD7
#define	 HIGH		     1
#define	 LOW			 2
#define  READCONTINUOUS  1
#define  READBUFFER      2
#define	 AT45DB041ID  	 0x1C
#define	 AT45DB081ID  	 0x24
#define	 AT45DB161ID  	 0x2C
#define	 AT45DB321ID  	 0x34
#define	 AT45DB642ID  	 0x24
#define  FLASHIDMASK	 0x3C
#define  FLASHCHIP_1	 1
#define  FLASHCHIP_2	 2

// Misc defines
#define 	NO  		  0x00
#define 	YES 		  0x01
#define 	ON  		  0x00
#define 	OFF 		  0x01
#define 	DEBUG 		  0

// TWI definitions
#define   TWI_GENERAL_CALL_ON  1
#define   TWI_SLAVE_ADDRESS 0x26
#define   TWI_START   		0x08
#define   TWI_STOP    		0xA0
#define   MT_SLA_ACK  		0x18
#define   MT_DATA_ACK 		0x28
#define   SR_WRITE_COMMAND 0x60
#define   SR_READ_COMMAND  0xA8
#define   SLA_W		  	   0x00
#define   SLA_R		  	   0x01
#define   QUIET 	  	   1
#define   VERBOSE	  	   2

#define	 KEY1				 1
#define	 KEY2				 2
#define  KEY3				 3
#define	 KEY4				 4

/*
* Defines the ranges that can be selected for the Accelerometer
*/
#define ACCELEROMETER_1g5 0
#define ACCELEROMETER_2g 1
#define ACCELEROMETER_4g 2
#define ACCELEROMETER_6g 3

/*
* Defines the sensitivity that can be selected for the Accelerometer
* mV/g
*/
#define ACCELEROMETER_1g5_SENSITIVITY 800
#define ACCELEROMETER_2g_SENSITIVITY 600
#define ACCELEROMETER_4g_SENSITIVITY 300
#define ACCELEROMETER_6g_SENSITIVITY 200

#define X_AXIS 0
#define Y_AXIS 1
#define Z_AXIS 2

/*
 *What port is the accelerometer connected to?
 */
#define ACCELEROMETER_CONTROL PORTB
/*
 *What port pins is the accelerometer connected to?
 */
#define GS1 3
#define GS2 4
#define SLEEP 5

#define SetBit(x,y) (x|=(1<<y)) 
#define ClrBit(x,y) (x&=~(1<<y)) 

