	.module SmartLCD_Utilities.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Utilities.c
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 74
; /**************************************************************
; 
;    Program Title:  SmartLCD Controller
;    
;    Program Name:  SmartLCD_Utilities.c	  Version: 0.85
;    
;    Author:  SS	  					  Date:  August 10, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.13A
;    
;    This file contains routines that implement a set of basic utility 
;    functions for the SmartLCD controller.
;    
;    Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: SmartLCD_Utilities.c,v $
;  * Revision 0.86  2006/02/07  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "SmartLCD_Uart.h"
; #include "SmartLCD_Defines.h"
; #include "SmartLCD_Extern.h"
; 
; //*********************************************************
; //*********************************************************
; //      Utilities
; //*********************************************************
; //*********************************************************
; void Delay(void)
; {
	.dbline 77
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	xjmp L5
L2:
	.dbline 78
; 		for (b = 1; b; b++)
	ldi R18,1
	xjmp L9
L6:
	.dbline 79
; 			;
L7:
	.dbline 78
	inc R18
L9:
	.dbline 78
	tst R18
	brne L6
X0:
L3:
	.dbline 77
	inc R16
L5:
	.dbline 77
	tst R16
	brne L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e ShortDelay _ShortDelay fV
;         inbyte -> R22
;              i -> R20,R21
;            cnt -> R16,R17
	.even
_ShortDelay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 83
; }
; 
; void ShortDelay(int cnt)
; {
	.dbline 87
;  	unsigned char inbyte;
; 	int i;
; 	
;     for(i=0; i<cnt; i++)  {
	clr R20
	clr R21
	xjmp L14
L11:
	.dbline 87
	.dbline 88
; 	    inbyte = 0x55;
	ldi R22,85
	.dbline 89
; 		}
L12:
	.dbline 87
	subi R20,255  ; offset = 1
	sbci R21,255
L14:
	.dbline 87
	cp R20,R16
	cpc R21,R17
	brlt L11
X2:
	.dbline -2
L10:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 22 c
	.dbsym r i 20 I
	.dbsym r cnt 16 I
	.dbend
	.dbfunc e LongDelay _LongDelay fV
;            cnt -> R20,R21
	.even
_LongDelay::
	st -y,R20
	st -y,R21
	movw R20,R16
	.dbline -1
	.dbline 93
; }
; 
; void LongDelay(int cnt)
; {
	xjmp L17
L16:
	.dbline 94
;  	 while(cnt > 0) {
	.dbline 95
; 	 	 Delay();
	xcall _Delay
	.dbline 96
; 		 cnt--;
	subi R20,1
	sbci R21,0
	.dbline 97
; 		 }
L17:
	.dbline 94
	clr R2
	clr R3
	cp R2,R20
	cpc R3,R21
	brlt L16
X3:
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r cnt 20 I
	.dbend
	.dbfunc e Delaymsec _Delaymsec fV
;     delayvalue -> R16,R17
	.even
_Delaymsec::
	.dbline -1
	.dbline 101
; }
; 
; void Delaymsec(int delayvalue)
; {
	.dbline 102
;  	 mseccountdown2 = delayvalue;
	sts _mseccountdown2+1,R17
	sts _mseccountdown2,R16
L20:
	.dbline 103
; 	 while(mseccountdown2) ;
L21:
	.dbline 103
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L20
	tst R3
	brne L20
X4:
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbsym r delayvalue 16 I
	.dbend
	.dbfunc e printint _printint fV
;           tens -> R22,R23
;      thousands -> R10,R11
;   tenthousands -> R10,R11
;       hundreds -> R10,R11
;       outvalue -> y+0
;       intvalue -> R20,R21
	.even
_printint::
	xcall push_xgsetF00C
	movw R20,R16
	sbiw R28,6
	.dbline -1
	.dbline 107
; }
; 
; void printint(int intvalue)
; {
	.dbline 112
;  	 char outvalue[6];
; 	 
;  	 int  tenthousands, thousands, hundreds, tens;
; 	 
; 	 if(intvalue >= 0) putchar(' ');
	cpi R20,0
	ldi R30,0
	cpc R21,R30
	brlt L24
X5:
	.dbline 112
	ldi R16,32
	ldi R17,0
	xcall _putchar
	xjmp L25
L24:
	.dbline 113
; 	 else {
	.dbline 114
; 	 	  putchar('-');
	ldi R16,45
	ldi R17,0
	xcall _putchar
	.dbline 115
; 	 	  intvalue *= -1;
	ldi R16,-1
	ldi R17,-1
	movw R18,R20
	xcall empy16s
	movw R20,R16
	.dbline 116
; 		  }
L25:
	.dbline 117
; 	 tenthousands = intvalue/10000;
	ldi R18,10000
	ldi R19,39
	movw R16,R20
	xcall div16s
	movw R10,R16
	.dbline 118
; 	 intvalue -= (tenthousands*10000);
	ldi R16,10000
	ldi R17,39
	movw R18,R10
	xcall empy16s
	sub R20,R16
	sbc R21,R17
	.dbline 119
; 	 thousands = intvalue/1000;
	ldi R18,1000
	ldi R19,3
	movw R16,R20
	xcall div16s
	movw R10,R16
	.dbline 120
; 	 intvalue -= (thousands*1000);
	ldi R16,1000
	ldi R17,3
	movw R18,R10
	xcall empy16s
	sub R20,R16
	sbc R21,R17
	.dbline 121
; 	 hundreds = intvalue/100;
	ldi R18,100
	ldi R19,0
	movw R16,R20
	xcall div16s
	movw R10,R16
	.dbline 122
; 	 intvalue -= (hundreds*100);
	ldi R16,100
	ldi R17,0
	movw R18,R10
	xcall empy16s
	sub R20,R16
	sbc R21,R17
	.dbline 123
; 	 tens = intvalue/10;
	ldi R18,10
	ldi R19,0
	movw R16,R20
	xcall div16s
	movw R22,R16
	.dbline 124
; 	 	  outvalue[0] = '0' + hundreds;
	movw R24,R10
	adiw R24,48
	std y+0,R24
	.dbline 125
; 	 	  outvalue[1] = '0' + tens;
	movw R24,R22
	adiw R24,48
	std y+1,R24
	.dbline 126
; 	 	  outvalue[2] = '.';
	ldi R24,46
	std y+2,R24
	.dbline 127
; 	 	  outvalue[3] = '0' + intvalue%10;
	ldi R18,10
	ldi R19,0
	movw R16,R20
	xcall mod16s
	movw R24,R16
	adiw R24,48
	std y+3,R24
	.dbline 128
; 	 	  outvalue[4] = 0x00;
	clr R2
	std y+4,R2
	.dbline 129
; 	 outvalue[5] = 0x00;
	std y+5,R2
	.dbline -2
L23:
	.dbline 0 ; func end
	adiw R28,6
	xjmp pop_xgsetF00C
	.dbsym r tens 22 I
	.dbsym r thousands 10 I
	.dbsym r tenthousands 10 I
	.dbsym r hundreds 10 I
	.dbsym l outvalue 0 A[6:6]c
	.dbsym r intvalue 20 I
	.dbend
	.dbfunc e hextobyte _hextobyte fc
;         inbyte -> R16
	.even
_hextobyte::
	xcall push_xgsetF000
	.dbline -1
	.dbline 133
; }
; 
; unsigned char hextobyte(unsigned char inbyte)
; {
	.dbline 134
; 	 if((inbyte >= 'A')&(inbyte<='F')) return (inbyte - 'A' + 10);
	cpi R16,65
	brlo L34
X6:
	ldi R22,1
	ldi R23,0
	xjmp L35
L34:
	clr R22
	clr R23
L35:
	ldi R24,70
	cp R24,R16
	brlo L36
X7:
	ldi R20,1
	ldi R21,0
	xjmp L37
L36:
	clr R20
	clr R21
L37:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X8
	tst R3
	breq L32
X8:
	.dbline 134
	mov R24,R16
	subi R24,65
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L31
L32:
	.dbline 135
; 	 if((inbyte >= 'a')&(inbyte<='f')) return (inbyte - 'a' + 10);
	cpi R16,97
	brlo L40
X9:
	ldi R22,1
	ldi R23,0
	xjmp L41
L40:
	clr R22
	clr R23
L41:
	ldi R24,102
	cp R24,R16
	brlo L42
X10:
	ldi R20,1
	ldi R21,0
	xjmp L43
L42:
	clr R20
	clr R21
L43:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X11
	tst R3
	breq L38
X11:
	.dbline 135
	mov R24,R16
	subi R24,97
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L31
L38:
	.dbline 136
; 	 else return (inbyte - '0');
	subi R16,48
	.dbline -2
L31:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 16 c
	.dbend
	.dbfunc e bytetohex _bytetohex fV
;         inchar -> <dead>
;         inbyte -> R20
;           byte -> R16
	.even
_bytetohex::
	st -y,R20
	.dbline -1
	.dbline 141
; }
; 
; //  Convert byte to ASCII hex
; void bytetohex(unsigned char byte)
; {
	.dbline 144
;     unsigned char inbyte,inchar;
; 	
; 	inbyte = byte & 0x0f;
	mov R20,R16
	andi R20,15
	.dbline 145
; 	if(inbyte > 9) hexbyte[1] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L45
X12:
	.dbline 145
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte+1,R24
	xjmp L46
L45:
	.dbline 146
; 	else hexbyte[1] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte+1,R24
L46:
	.dbline 147
; 	inbyte = byte & 0xf0;
	mov R20,R16
	andi R20,240
	.dbline 148
; 	inbyte >>= 4;
	mov R24,R20
	swap R24
	andi R24,#0x0F
	mov R20,R24
	.dbline 149
; 	if(inbyte >9) hexbyte[0] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L49
X13:
	.dbline 149
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte,R24
	xjmp L50
L49:
	.dbline 150
; 	else hexbyte[0] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte,R24
L50:
	.dbline 151
;     hexbyte[2] = 0x00;
	clr R2
	sts _hexbyte+2,R2
	.dbline -2
L44:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym l inchar 1 c
	.dbsym r inbyte 20 c
	.dbsym r byte 16 c
	.dbend
	.dbfunc e EEPROM_write _EEPROM_write fV
;         ucData -> R18
;      uiAddress -> R16,R17
	.even
_EEPROM_write::
	.dbline -1
	.dbline 155
; }
; 
; void  EEPROM_write(int uiAddress,unsigned char ucData)
; {
L53:
	.dbline 157
;     //  Wait for completion of previous write
; 	while(EECR&(1<<EEPE));
L54:
	.dbline 157
	sbic 0x1f,1
	rjmp L53
X14:
	.dbline 160
; 	
; 	// Set up address and Data registers
; 	EEAR = uiAddress;
	out 0x22,R17
	out 0x21,R16
	.dbline 161
; 	EEDR = ucData;
	out 0x20,R18
	.dbline 164
; 	
; 	// Write logical one to EEMPE
; 	EECR |= (1<<EEMPE);
	sbi 0x1f,2
	.dbline 167
; 	
; 	// Start eeprom write by setting EEPE
; 	EECR |= (1<<EEPE);
	sbi 0x1f,1
	.dbline -2
L52:
	.dbline 0 ; func end
	ret
	.dbsym r ucData 18 c
	.dbsym r uiAddress 16 I
	.dbend
	.dbfunc e EEPROM_read _EEPROM_read fc
;      uiAddress -> R16,R17
	.even
_EEPROM_read::
	.dbline -1
	.dbline 171
; }
; 
; unsigned char EEPROM_read(int uiAddress)
; {
L57:
	.dbline 173
;     // Wait for completion of previous write
; 	while(EECR&(1<<EEPE));
L58:
	.dbline 173
	sbic 0x1f,1
	rjmp L57
X15:
	.dbline 176
; 	
; 	// Setup address
; 	EEAR = uiAddress;
	out 0x22,R17
	out 0x21,R16
	.dbline 179
; 	
; 	// Start eeprom read by writing EERE
; 	EECR |= (1<<EERE);
	sbi 0x1f,0
	.dbline 182
; 	
; 	// Return data from data register
; 	return EEDR;
	in R16,0x20
	.dbline -2
L56:
	.dbline 0 ; func end
	ret
	.dbsym r uiAddress 16 I
	.dbend
	.dbfunc e LED_Power _LED_Power fV
;          state -> R16
	.even
_LED_Power::
	.dbline -1
	.dbline 186
; }
; 
; void LED_Power(unsigned char state)
; {
	.dbline 187
;  	 if(state==ON)  ClrBit(PORTD,PIND5);
	tst R16
	brne L61
X16:
	.dbline 187
	cbi 0xb,5
	xjmp L62
L61:
	.dbline 188
; 	 else  SetBit(PORTD,PIND5);
	sbi 0xb,5
L62:
	.dbline -2
L60:
	.dbline 0 ; func end
	ret
	.dbsym r state 16 c
	.dbend
	.dbfunc e LCD_LED_Power _LCD_LED_Power fV
;          state -> R16
	.even
_LCD_LED_Power::
	.dbline -1
	.dbline 192
; }
; 
; void LCD_LED_Power(unsigned char state)
; {
	.dbline 193
;  	 if(state==ON)  SetBit(PORTD,PIND6);
	tst R16
	brne L64
X17:
	.dbline 193
	sbi 0xb,6
	xjmp L65
L64:
	.dbline 194
; 	 else  ClrBit(PORTD,PIND6);
	cbi 0xb,6
L65:
	.dbline -2
L63:
	.dbline 0 ; func end
	ret
	.dbsym r state 16 c
	.dbend
	.dbfunc e CheckKeyState _CheckKeyState fc
;          inkey -> R20
;            key -> R16
	.even
_CheckKeyState::
	st -y,R20
	.dbline -1
	.dbline 200
; }
; 
; // Key 1 is far left Key 4 is far right
; // Key pressed is active low
; unsigned char CheckKeyState(unsigned char key)
; {
	.dbline 203
;  	unsigned char inkey;
; 	
;  	if(key==KEY1) inkey = PIND&0x04;
	cpi R16,1
	brne L67
X18:
	.dbline 203
	in R20,0x9
	andi R20,4
	xjmp L68
L67:
	.dbline 204
; 	else if(key==KEY2) inkey = PIND&0x08;
	cpi R16,2
	brne L69
X19:
	.dbline 204
	in R20,0x9
	andi R20,8
	xjmp L70
L69:
	.dbline 205
; 	else if(key==KEY3) inkey = PIND&0x10;
	cpi R16,3
	brne L71
X20:
	.dbline 205
	in R20,0x9
	andi R20,16
	xjmp L72
L71:
	.dbline 206
; 	else if(key==KEY4) inkey = PIND&0x80;
	cpi R16,4
	brne L73
X21:
	.dbline 206
	in R20,0x9
	andi R20,128
	xjmp L74
L73:
	.dbline 207
; 	else return 1;
	ldi R16,1
	xjmp L66
L74:
L72:
L70:
L68:
	.dbline 208
; 	if(inkey>0) return 0;
	ldi R24,0
	cp R24,R20
	brsh L75
X22:
	.dbline 208
	clr R16
	xjmp L66
L75:
	.dbline 209
; 	else return 1;
	ldi R16,1
	.dbline -2
L66:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r inkey 20 c
	.dbsym r key 16 c
	.dbend
	.dbfunc e Read_ADC _Read_ADC fI
;           high -> R12
;            low -> R10
;        channel -> R20
	.even
_Read_ADC::
	xcall push_xgset303C
	mov R20,R16
	.dbline -1
	.dbline 213
; }
; 
; int Read_ADC(unsigned char channel)
; {
	.dbline 216
;  	unsigned char low,high;
; 	
;  	if(channel==0)  {
	tst R20
	brne L78
X23:
	.dbline 216
	.dbline 217
; 	    ADMUX = (1<<REFS1)|(1<<REFS0);  // use internal vref, ADC0
	ldi R24,192
	sts 124,R24
	.dbline 218
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	sts 122,R24
	.dbline 219
; 		}
	xjmp L89
L78:
	.dbline 220
; 	else if(channel==1) {
	cpi R20,1
	brne L80
X24:
	.dbline 220
	.dbline 221
; 	    ADMUX = 0x01|(1<<REFS0);   //  ADC6  use external AVCC
	ldi R24,65
	sts 124,R24
	.dbline 222
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 223
; 	    }
	xjmp L89
L80:
	.dbline 224
; 	else if(channel==2) {
	cpi R20,2
	brne L82
X25:
	.dbline 224
	.dbline 225
; 	    ADMUX = 0x02|(1<<REFS0);   //  ADC7
	ldi R24,66
	sts 124,R24
	.dbline 226
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 227
; 	    }
	xjmp L89
L82:
	.dbline 228
; 	else if(channel==6) {
	cpi R20,6
	brne L84
X26:
	.dbline 228
	.dbline 229
; 	    ADMUX = 0x06|(1<<REFS0);   //  ADC6
	ldi R24,70
	sts 124,R24
	.dbline 230
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 231
; 	    }
	xjmp L89
L84:
	.dbline 232
; 	else if(channel==7) {
	cpi R20,7
	brne L86
X27:
	.dbline 232
	.dbline 233
; 	    ADMUX = 0x07|(1<<REFS0);   //  ADC7
	ldi R24,71
	sts 124,R24
	.dbline 234
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 235
; 	    }
	xjmp L89
L86:
	.dbline 236
; 	else return 0;
	clr R16
	clr R17
	xjmp L77
L88:
	.dbline 238
; 	
; 	while(!(ADCSRA&(1<<ADIF))) ;  // wait for adc to complete
L89:
	.dbline 238
	lds R2,122
	sbrs R2,4
	rjmp L88
X28:
	.dbline 239
; 	low = ADCL;
	lds R10,120
	.dbline 240
; 	high = ADCH;
	lds R12,121
	.dbline 241
; 	return (low+high*256);
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	add R16,R2
	adc R17,R3
	.dbline -2
L77:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r high 12 c
	.dbsym r low 10 c
	.dbsym r channel 20 c
	.dbend
	.dbfunc e setAccelerometerRange _setAccelerometerRange fV
;          range -> R16
	.even
_setAccelerometerRange::
	.dbline -1
	.dbline 247
; }
; 
; int sensitivity;
; 
; void setAccelerometerRange(unsigned char range)
; {
	.dbline 248
; 	if (range == ACCELEROMETER_1g5) {
	tst R16
	brne L92
X29:
	.dbline 248
	.dbline 249
; 	   	ACCELEROMETER_CONTROL &= ~((1<<GS1)|(1<<GS2));//clear GS1 and GS2
	in R24,0x5
	andi R24,231
	out 0x5,R24
	.dbline 250
; 		sensitivity = ACCELEROMETER_1g5_SENSITIVITY;
	ldi R24,800
	ldi R25,3
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 251
; 	    }
	xjmp L93
L92:
	.dbline 252
; 	else if (range == ACCELEROMETER_2g) {
	cpi R16,1
	brne L94
X30:
	.dbline 252
	.dbline 253
; 		ACCELEROMETER_CONTROL &= ~(1<<GS2);//clear GS2
	cbi 0x5,4
	.dbline 254
; 		ACCELEROMETER_CONTROL |= (1<<GS1);//set GS1
	sbi 0x5,3
	.dbline 255
; 		sensitivity = ACCELEROMETER_2g_SENSITIVITY;
	ldi R24,600
	ldi R25,2
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 256
; 	    }
	xjmp L95
L94:
	.dbline 257
; 	else if (range == ACCELEROMETER_4g) {
	cpi R16,2
	brne L96
X31:
	.dbline 257
	.dbline 258
; 		ACCELEROMETER_CONTROL &= ~(1<<GS1);//Clear GS1
	cbi 0x5,3
	.dbline 259
; 		ACCELEROMETER_CONTROL |= (1<<GS2);//Set GS2
	sbi 0x5,4
	.dbline 260
; 		sensitivity = ACCELEROMETER_4g_SENSITIVITY;
	ldi R24,300
	ldi R25,1
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 261
; 	    }
	xjmp L97
L96:
	.dbline 262
; 	else if (range == ACCELEROMETER_6g) {
	cpi R16,3
	brne L98
X32:
	.dbline 262
	.dbline 263
; 	 	ACCELEROMETER_CONTROL |= ((1<<GS1)|(1<<GS2));//Set GS1 & GS2
	in R24,0x5
	ori R24,24
	out 0x5,R24
	.dbline 264
; 		sensitivity = ACCELEROMETER_6g_SENSITIVITY;
	ldi R24,200
	ldi R25,0
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 265
; 	    }
L98:
L97:
L95:
L93:
	.dbline -2
L91:
	.dbline 0 ; func end
	ret
	.dbsym r range 16 c
	.dbend
	.dbfunc e enableAccelerometer _enableAccelerometer fV
;          sleep -> R16
	.even
_enableAccelerometer::
	.dbline -1
	.dbline 269
; }
; 
; void enableAccelerometer(unsigned char sleep)
; {
	.dbline 270
;  	 if(sleep == OFF){	  
	cpi R16,1
	brne L101
X33:
	.dbline 270
	.dbline 271
; 	 	ACCELEROMETER_CONTROL &= ~(1<<SLEEP); // Disable Accelerometer
	cbi 0x5,5
	.dbline 272
; 	    }
	xjmp L102
L101:
	.dbline 273
; 	 else {
	.dbline 274
; 	  	ACCELEROMETER_CONTROL |= (1<<SLEEP); // Enable Accelerometer
	sbi 0x5,5
	.dbline 275
; 	    }
L102:
	.dbline -2
L100:
	.dbline 0 ; func end
	ret
	.dbsym r sleep 16 c
	.dbend
	.dbfunc e readAccelerometer _readAccelerometer fI
;          value -> R10,R11
;           axis -> R20
	.even
_readAccelerometer::
	xcall push_xgset303C
	mov R20,R16
	.dbline -1
	.dbline 280
; }
; 
; 
; int readAccelerometer(unsigned char axis)
; {
	.dbline 281
;  	int value = 0;
	clr R10
	clr R11
	.dbline 283
; 	
;  	if(axis == X_AXIS)  {
	tst R20
	brne L104
X34:
	.dbline 283
	.dbline 284
; 		value = Read_ADC(0x01);// ADC1
	ldi R16,1
	xcall _Read_ADC
	movw R10,R16
	.dbline 285
; 		}
	xjmp L105
L104:
	.dbline 286
; 	else if(axis == Y_AXIS) {
	cpi R20,1
	brne L106
X35:
	.dbline 286
	.dbline 287
; 	    value = Read_ADC(0x06);  //  ADC6
	ldi R16,6
	xcall _Read_ADC
	movw R10,R16
	.dbline 288
; 	    }
	xjmp L107
L106:
	.dbline 289
; 	else if(axis == Z_AXIS) {
	cpi R20,2
	brne L108
X36:
	.dbline 289
	.dbline 290
; 	    value = Read_ADC(0x07); //  ADC7
	ldi R16,7
	xcall _Read_ADC
	movw R12,R16
	movw R10,R12
	.dbline 292
; 		
; 	    }
L108:
L107:
L105:
	.dbline 294
; 
; 	return value;
	movw R16,R10
	.dbline -2
L103:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r value 10 I
	.dbsym r axis 20 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Utilities.c
_sensitivity::
	.blkb 2
	.dbsym e sensitivity _sensitivity I
; }
; 
